/*
 * CountRotator class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util;

import java.io.Serializable;

/**
 * 循環カウンタクラス。
 * <br>
 * カウンタの値を保持し、それを一つずつ加算していくためのメソッドを
 * 用意している。
 * カウンタの初期値、下限値、上限値は、デフォルトでは
 * 0、{@link java.lang.Long#MIN_VALUE}、{@link java.lang.Long#MAX_VALUE}
 * に設定されるが、コンストラクタで任意の値を指定することもできる。
 * <br>
 * カウンタは1ずつ加算されるが、最大値に至ったところでさらに加算すると
 * 最小値に設定され、カウンタの値は循環する。
 * <br>
 * このクラスの直接のインスタンスはマルチスレッドに対応していないが、
 * {@link ts.util.CountRotate#synchronizedCountRotate}メソッドを使用して、
 * スレッドセーフなインスタンスを作成することができる。
 *
 * @author  佐藤隆之. 
 * @version $Revision: 1.2 $, $Date: 2011-08-01 15:29:29 $
 */
public class CountRotate implements Serializable
{
  /** シリアル・バージョン番号。 */
  static final long serialVersionUID = 7115246801504112856L;

  /** カウンタ。 */
  private long value_ ;

  /** 下限値。 */
  private long minLimit_ ;

  /** 上限値。 */
  private long maxLimit_ ;

  /**
   * デフォルトコンストラクタ。
   * <br>
   * カウンタの初期値をゼロ、下限値を{@link java.lang.Long#MIN_VALUE}、
   * 上限値を{@link java.lang.Long#MAX_VALUE}に設定する。
   */
  public CountRotate()
  {
    value_ = 0L;
    minLimit_ = Long.MIN_VALUE;
    maxLimit_ = Long.MAX_VALUE;
  }

  /**
   * カウンタの初期値を引数にとるコンストラクタ。
   * <br>
   * カウンタの下限値を{@link java.lang.Long#MIN_VALUE}、
   * 上限値を{@link java.lang.Long#MAX_VALUE}に設定する。
   *
   * @param  init カウンタの初期値。
   */
  public CountRotate(long init)
  {
    value_ = init;
    minLimit_ = Long.MIN_VALUE;
    maxLimit_ = Long.MAX_VALUE;
  }

  /**
   * カウンタの初期値、下限値、上限値を引数にとるコンストラクタ。
   * <br>
   * 初期値が下限値より小さい場合は、初期値を下限値に設定する。
   * 初期値が上限値より大きい場合は、初期値を上限値に設定する。
   * 下限値と上限値の大小関係が逆の場合は、お互いに値を入れ替える。
   *
   * @param  init カウンタの初期値。
   * @param  min  カウンタの下限値。
   * @param  max  カウンタの上限値。
   */
  public CountRotate(long init, long min, long max)
  {
    if (min > max) {
      minLimit_ = max;
      maxLimit_ = min;
    }
    else {
      minLimit_ = min;
      maxLimit_ = max;
    }

    if (init < minLimit_) {
      value_ = minLimit_;
    }
    else if (init > maxLimit_) {
      value_ = maxLimit_;
    }
    else {
      value_ = init;
    }
  }

  /**
   * 現在のカウンタ値を取得する。
   *
   * @return 現在のカウンタ値。
   */
  public long currentValue()
  {
    return value_ ;
  }

  /**
   * カウンタを一つ加算する。
   * <br>
   * 加算する前のカウンタ値が最大値{@link java.lang.Long#MAX_VALUE}の場合は、
   * 加算した後{@link java.lang.Long#MIN_VALUE}になる。
   *
   * @return 加算後のカウンタの値。
   */
  public long increment()
  {
    if (value_ >= maxLimit_) {
      value_ = minLimit_ ;
    }
    else {
      value_ ++;
    }

    return value_ ;
  }

  /**
   * スレッドセーフな循環カウンタオブジェクトを生成する。
   * <br>
   * カウンタの初期値はゼロとする。
   *
   * @return スレッドセーフな循環カウンタオブジェクト。
   */
  public static CountRotate synchronizedCountRotate()
  {
    return synchronizedCountRotate(0L);
  }

  /**
   * カウンタの初期値を指定してスレッドセーフな循環カウンタオブジェクトを
   * 生成する。
   *
   * @param  init カウンタの初期値。
   * @return スレッドセーフな循環カウンタオブジェクト。
   */
  public static CountRotate synchronizedCountRotate(long init)
  {
    return new CountRotate(init) {
      static final long serialVersionUID = 7115246801504112857L;

      @Override
      public synchronized long currentValue() {
        return super.currentValue();
      }
      @Override
      public synchronized long increment() {
        return super.increment();
      }
    };
  }

  /**
   * カウンタの初期値、下限値、上限値を指定してスレッドセーフな
   * 循環カウンタオブジェクトを生成する。
   *
   * @param  init カウンタの初期値。
   * @param  min  カウンタの下限値。
   * @param  max  カウンタの上限値。
   * @return スレッドセーフな循環カウンタオブジェクト。
   */
  public static CountRotate synchronizedCountRotate(
    long init, long min, long max)
  {
    return new CountRotate(init, min, max) {
      static final long serialVersionUID = 7115246801504112858L;

      @Override
      public synchronized long currentValue() {
        return super.currentValue();
      }
      @Override
      public synchronized long increment() {
        return super.increment();
      }
    };
  }

  /**
   * 指定された循環カウンタオブジェクトの現在の値を使用して、スレッドセーフな
   * 循環カウンタオブジェクトを新たに生成する。
   *
   * @param  c 元になる循環カウンタオブジェクト。
   * @return スレッドセーフな循環カウンタオブジェクト。
   * @throws AssertionError 引数がヌルの場合（デバッグモードのみ）。
   */
  public static CountRotate synchronizedCountRotate(CountRotate c)
  {
    assert (c != null) : "@param:c is null.";

    return synchronizedCountRotate(c.value_, c.minLimit_, c.maxLimit_);
  }
}
